/*
 * Copyright 2004 Bundeskanzleramt sterreich
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package moazs;
import java.io.IOException;
import java.io.OutputStream;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import moazs.util.MoaFactory;

public class Moazs extends HttpServlet {

  private static final long serialVersionUID = -1401482387282844781L;

    public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {
        String res = "";
        String prefix = request.getContextPath();
        String reqURI = request.getRequestURI();
                
        String target = reqURI.substring(reqURI.indexOf(prefix)+prefix.length(), reqURI.length());
        target = target.substring(target.lastIndexOf("/")+1 , target.length());

        OutputStream out = response.getOutputStream();
        if (target.equals("ping")) {
            response.setContentType("text/plain");
            res = pong();
        } else {
            response.setContentType("text/html");
            res = hello();
        }
        out.write(res.getBytes("utf-8"));
        out.flush();
        out.close();
    }

    public String hello() {
        String res = "<html>\n<head>\t<title>Information</title></head>\n";
        res += "\t<body>\n\t\t<h1>Main Information</h1>\n";
        res += "\tVersion: " + Constants.VERSION + "<br>\n";
        res += "\tQueue: " + MoaFactory.getQueue().size() + "<br>\n";
        res += "\tThreads: " + MoaFactory.getQueue().getCount() + "<br>\n";


        res += "\n\t</body>\n</html>\n";
        return res;
    }

    public String getHTML(String title, String message) {
      String res = "<html>\n<head>\t<title>" + title + "</title></head>\n";
      res += "\t<body>\n\t\t<h1>" + title + "</h1>\n";
      res += message;
      res += "\n\t</body>\n</html>\n";
      return res;
  }

    
    public String pong() {
        String res = "pong";
        return res;
    }

}

