/*
 * Copyright 2004 Bundeskanzleramt sterreich
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package moazs.api;

/**
 * ExceptionKlasse fr MoaZS
 */
public class MoaException extends Exception {

  private static final long serialVersionUID = -3888161632445157075L;

  private int errorCode = -1;
  
  public MoaException(String msg) {
    super(msg);
  }

  public MoaException(String message, int errorCode) {
    super(message);
    this.errorCode = errorCode;
  }

  public MoaException(int errorCode, String message) {
    super(message);
    this.errorCode = errorCode;
  }
  
  public MoaException(String message, Throwable cause) {
    super(message, cause);
  }

  public MoaException(Throwable cause) {
    super(cause);
  }

  public int getErrorCode() {
    return errorCode;
  }
  
}
