package moazs.api.dn.impl;

import java.io.IOException;

import moazs.api.MoaException;
import moazs.api.dn.AbstractDeliveryNotificationHandler;
import moazs.util.MoaXMLUtils;

import org.apache.log4j.Logger;
import org.w3c.dom.Element;

/*
 * writes the delivery notification element to the log file
 */
public class LogDeliveryNotificationHandler extends
    AbstractDeliveryNotificationHandler {

  static private Logger logger = Logger.getLogger(LogDeliveryNotificationHandler.class);
  
  public void handleZUSEDeliveryNotification(Element deliveryNotificationElement)
      throws MoaException {
    try {
      logger.info(MoaXMLUtils.serializeToString(deliveryNotificationElement, true));
    } catch (IOException e) {
      logger.warn("Error writing ZUSE delivery notification to log-file.", e);
    }

  }

  public void handleMZSDeliveryNotification(Element deliveryNotificationElement)
      throws MoaException {
    try {
      logger.info(MoaXMLUtils.serializeToString(deliveryNotificationElement, true));
    } catch (IOException e) {
      logger.warn("Error writing MZS delivery notification to log-file.", e);
    }
    
  }


}
