package moazs.aspects;

import java.util.logging.Level;
import java.util.logging.Logger;

import moazs.modell.Request;

import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.reflect.CodeSignature;

public aspect LoggingRequestsAspect {

    private static Logger _requestLogger = Logger.getLogger("moa-request");

    /**
     *  
     */
    public LoggingRequestsAspect() {
        /*
        FileHandler rfh = null;
        try {
            rfh = new FileHandler("%t/request%u.log", 1000000, 1);
            rfh.setFormatter(new MoaLogFormatter());
            
        } catch (SecurityException se) {
            se.printStackTrace();
        } catch (IOException ioe) {
            ioe.printStackTrace();
        }
        Logger.getLogger("moa-request").addHandler(rfh);
        Logger.getLogger("moa-request").setLevel(Level.INFO);
        */
    }
    
    pointcut logRequestMethods(Request r) : execution(* *(Session,Request)) && args(*, r);
/*
    pointcut logAllRequests(Request r) : 
        call(* *(*)) && args(r)
        && !within(moazs.aspects.*);
    
    pointcut logRequests(Request r) : 
        target(r) && call(public * *(..))
        && !within(moazs.aspects.*);
    
  */  
    before(Request r): logRequestMethods(r) {
	    if (_requestLogger.isLoggable(Level.INFO)) {
	        _requestLogger.logp(Level.INFO,
                thisJoinPoint.getSignature().getDeclaringType().getName(),
                thisJoinPoint.getSignature().getName(),
                //"requestid " + r.getId() + printRequestParameters(thisJoinPoint));
                "RequestId(MoazsID): " + r.getId() + " AppID: " + r.getAppDeliveryId() + " EingangsTS: " + r.getTs());
	    }
    }    
  /*
    before(Request r): logAllRequests(r) {
	    if (_requestLogger.isLoggable(Level.INFO)) {
	        _requestLogger.logp(Level.INFO,
                thisJoinPoint.getSignature().getDeclaringType().getName(),
                thisJoinPoint.getSignature().getName(),
                "RequestId(MoazsID): " + r.getId() + " AppID: " + r.getAppDeliveryId() + " EingangsTS: " + r.getTs());
	    }
    }

    before(Request r): logRequests(r) {
	    if (_requestLogger.isLoggable(Level.INFO)) {
	        _requestLogger.logp(Level.INFO,
                thisJoinPoint.getSignature().getDeclaringType().getName(),
                thisJoinPoint.getSignature().getName(),
                "RequestId(MoazsID): " + r.getId() + " AppID: " + r.getAppDeliveryId() + " EingangsTS: " + r.getTs());
	    }
    }
    */
	static private String printRequestParameters(JoinPoint jp) {
	    StringBuffer sb = new StringBuffer();
	    sb.append("Arguments: " );
	    Object[] args = jp.getArgs();
	    String[] names = ((CodeSignature)jp.getSignature()).getParameterNames();
	    //Class[] types = ((CodeSignature)jp.getSignature()).getParameterTypes();
	    for (int i = 0; i < args.length; i++) {
	        sb.append("  ");
	        sb.append(i);
	        sb.append(". ");
	        sb.append(names[i]);
	        //sb.append(" : ");
	        //sb.append(types[i].getName());
	        sb.append(" = ");
	        sb.append(args[i]);       
	    }
    return sb.toString();
	}

}
