package moazs.aspects;


import java.io.IOException;
import java.io.File;
import java.util.logging.Logger;
import java.util.logging.FileHandler;
import java.util.logging.Level;

public aspect SingleStepWithFileAspect {

    private static Logger _steplogger = Logger.getLogger("singleStep");
    
    SingleStepWithFileAspect() {
    }
    
    pointcut singleStepMode() : 
        execution(private int *.*(..))
        && within(moazs.async.MoaWorker);
    
    int around() : singleStepMode() {
        moazs.util.MoaConfig mcf = new moazs.util.MoaConfig();
        String testFile = mcf.getProperty("singleStep");
        if (testFile != null) {
            boolean step = true;
            File f = new File(testFile);
            while (step) {
                _steplogger.info("zum ausfuehren des naechsten schrittes, file " + testFile + " loeschen");                
                if (!f.exists()) step = false;
                try {
                Thread.sleep(5000);
                }catch (Exception e){}
            }
        }
        try {
            return proceed();
        } finally {
            try {
                if (testFile != null) {                    
                	File fn = new File(testFile);
                	fn.createNewFile();
                }
            } catch (IOException ie) {
                
            }
        }
    }
    
}
