/*
 * Copyright 2004 Bundeskanzleramt sterreich
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



package moazs.modell;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class DeliveryQuality {
    private long id;
    private String name;

    // delivery qualities for gov delivery
    public static final String RSA = "RSa";
    public static final String RSA_PLUS = "RSa+";
    
    public static final String nonRSA = "nonRSa";
    public static final String nonRSA_PLUS = "nonRSa+";

    // only for dual delivery (not electronically addressable)
    public static final String RSB = "RSb";
    public static final String RSB_PLUS = "RSb+";
    
    // delivery qualitites for private delivery
    public static final String R = "R";
    public static final String R_PLUS = "R+";

    public static final String RS = "RS";
    public static final String RS_PLUS = "RS+";
    
    public static final List GOVERNMENTAL_DQ = Arrays.asList(new String[] { RSA, RSA_PLUS, nonRSA, nonRSA_PLUS, RSB, RSB_PLUS });
    public static final List DUAL_DELIVERY_DQ = Arrays.asList(new String[] { RSB, RSB_PLUS });
    public static final List PRIVATE_DQ = Arrays.asList(new String[] { R, R_PLUS, RS, RS_PLUS });
    
    public void DeliveryQuality() {
    }

    public void setId(long id) {
        this.id = id;
    }

    public long getId() {
        return this.id;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getName() {
        return this.name;
    }
}

