/*
 * Copyright 2004 Bundeskanzleramt sterreich
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package moazs.modell;

import java.util.Date;
import java.util.Set;
import java.util.HashSet;

/**
 * @has 1 - 0..* moazs.modell.Identification
 * @has 1 - 0..* moazs.modell.Internetaddress
 * @has 1 - 0..* moazs.modell.Postaladdress
 * @has 1 - 0..* moazs.modell.Telephone

 */


public class Rcpt {
    private long id;
    private String zusebpk;
    private boolean physicalPerson;

    private String givenname;
    private String familyname;
    private boolean primary;
    private String prefix;
    private Date dateofbirth;
    
    private String fullname;
    private String organisation;

    private Set identification;
    private Set internetaddress;
    private Set postaladdress;
    private Set telephone;
  
    public Rcpt() {
    }

    public long getId() {
        return this.id;
    }

    public void setId( long id) {
        this.id = id;
    }

    public String getZusebpk() {
        return this.zusebpk;
    }

    public void setZusebpk(String zusebpk) {
        this.zusebpk = zusebpk;
    }

    public boolean getPhysicalPerson() {
        return this.physicalPerson;
    }

    public void setPhysicalPerson(boolean physicalPerson) {
        this.physicalPerson = physicalPerson;
    }

    public String getGivenname() {
        return this.givenname;
    }

    public void setGivenname(String givenname) {
        this.givenname = givenname;
    }

    public String getFamilyname() {
        return this.familyname;
    }

    public void setFamilyname(String familyname) {
        this.familyname = familyname;
    }
 
    public boolean getPrimary() {
        return this.primary;
    }

    public void setPrimary(boolean primary) {
        this.primary = primary;
    }
 
    public String getPrefix() {
        return this.prefix;
    }

    public void setPrefix(String prefix) {
        this.prefix = prefix;
    }
 
    public Date getDateofbirth() {
        return this.dateofbirth;
    }

    public void setDateofbirth(Date dateofbirth) {
        this.dateofbirth = dateofbirth;
    }

    public String getFullname() {
        return this.fullname;
    }

    public void setFullname(String fullname) {
        this.fullname = fullname;
    }

    public String getOrganisation() {
        return this.organisation;
    }

    public void setOrganisation(String organisation) {
        this.organisation = organisation;
    }

    public Set getIdentification() {
        return this.identification;
    };

    public void setIdentification(Set identification) {
        this.identification = identification;
    }

    public void addIdentification(Identification id) {
        if (this.identification == null) {
            this.identification = new HashSet();
        }
        this.identification.add(id);
    }
    
    public Set getInternetaddress() {
        return this.internetaddress;
    }
    
    public void setInternetaddress(Set internetaddress) {
        this.internetaddress = internetaddress;
    }
   
    public void addInternetaddress(Internetaddress email) {
        if (this.internetaddress == null) {
            this.internetaddress = new HashSet();
        }
        this.internetaddress.add(email);
    }
   
    public Set getPostaladdress() {
        return this.postaladdress;
    }
    
    public void setPostaladdress(Set postaladdress) {
        this.postaladdress = postaladdress;
    }
   
    public void addPostaladdress(Postaladdress post) {
        if (this.postaladdress == null) {
            this.postaladdress = new HashSet();
        }
        this.postaladdress.add(post);
    }
   
    public Set getTelephone() {
        return this.telephone;
    }
    
    public void setTelephone( Set telephone) {
        this.telephone = telephone;
    }

    public void addTelephone(Telephone telephone) {
        if (this.telephone == null) {
            this.telephone = new HashSet();
        }
        this.telephone.add(telephone);
    }

}
