/*
 * Copyright 2004 Bundeskanzleramt sterreich
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package moazs.modell;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.Blob;
import java.sql.SQLException;

import moazs.util.MiscUtil;

import org.hibernate.Hibernate;

public class XmlDocument {
    private long id;
    private String xmlProfileId;
    private String filename;
    private String mimetype;
    private String resultingMimetype;
    private String xpath;
    private int xpathIndex = 0;
    
    private String pstylesheetName;
    private Blob sstylesheet;
    private Blob pstylesheet;

    private Blob data;
    
    public XmlDocument() {
    }

    public long getId() {
        return this.id;
    }

    public void setId( long id) {
        this.id = id;
    }

    public String getXmlProfileId() {
        return this.xmlProfileId;
    }

    public void setXmlProfileId( String xmlProfileId) {
        this.xmlProfileId = xmlProfileId;
    }

    public String getFilename() {
        return this.filename;
    }

    public void setFilename( String filename) {
        this.filename = filename;
    }
    
    public String getMimetype() {
        return this.mimetype;
    }
    
    public void setMimetype( String mimetype) {
        this.mimetype = mimetype;
    }
 
    public String getResultingMimetype() {
        return this.resultingMimetype;
    }
    
    public void setResultingMimetype( String resultingMimetype) {
        this.resultingMimetype = resultingMimetype;
    }
   
    public String getXpath() {
        return this.xpath;
    }

    public void setXpath(String xpath) {
        this.xpath = xpath;
    }
    
    public int getXpathIndex() {
        return this.xpathIndex;
    }

    public void setXpathIndex( int xpathIndex) {
        this.xpathIndex = xpathIndex;
    }

    public String getPstylesheetName() {
        return this.pstylesheetName;
    }

    public void setPstylesheetName( String pstylesheetName) {
        this.pstylesheetName = pstylesheetName;
    }

    public Blob getSstylesheet() {
        return this.sstylesheet;
    }
    
    public byte[] getSStyleSheetAsByteArray() throws IOException {
      try {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        MiscUtil.dumpInputOutputStream(sstylesheet.getBinaryStream(), bos);
        return bos.toByteArray();
      } catch(SQLException e) {
        throw new IOException(e.getMessage());
      }
    }

    public void setSstylesheet(Blob sstylesheet) {
        this.sstylesheet = sstylesheet;
    }
    
    public void setSstylesheet(byte[] sstylesheet) {
      this.sstylesheet = Hibernate.createBlob(sstylesheet);
    }
    
    public void setSstylesheet(InputStream sstylesheet) throws IOException {
      this.sstylesheet = Hibernate.createBlob(sstylesheet);
    }
    
   public Blob getPstylesheet() {
        return this.pstylesheet;
    }

   public byte[] getPStyleSheetAsByteArray() throws IOException {
     try {
       ByteArrayOutputStream bos = new ByteArrayOutputStream();
       MiscUtil.dumpInputOutputStream(pstylesheet.getBinaryStream(), bos);
       return bos.toByteArray();
     } catch(SQLException e) {
       throw new IOException(e.getMessage());
     }
   }
   
    public void setPstylesheet(Blob pstylesheet) {
        this.pstylesheet = pstylesheet;
    }
    
    public void setPstylesheet(byte[] pstylesheet) {
      this.pstylesheet = Hibernate.createBlob(pstylesheet);
    }
    
    public void setPstylesheet(InputStream pstylesheet) throws IOException {
      this.pstylesheet = Hibernate.createBlob(pstylesheet);
    }

    public Blob getData() {
        return this.data;
    }

    public void setData(Blob data) {
        this.data = data;
    }
    
    public void setData(byte[] data) {
      this.data = Hibernate.createBlob(data);
    }
    
    public void setData(InputStream data) throws IOException {
      this.data = Hibernate.createBlob(data);
    }
    
    public byte[] getDataAsByteArray() throws IOException {
      try {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        MiscUtil.dumpInputOutputStream(data.getBinaryStream(), bos);
        return bos.toByteArray();
      } catch(SQLException e) {
        throw new IOException(e.getMessage());
      }
    }

}
