/*
 * Copyright 2004 Bundeskanzleramt sterreich
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package moazs.modell; 

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.sql.Blob;
import java.sql.SQLException;

import org.hibernate.Hibernate;

import moazs.util.MiscUtil;

public class Zuseserver {
    private long id;
    private String url;
    private Blob cert;
    private String mimetypes;
    private String bPK;


    public Zuseserver() {
    }

    public long getId() {
        return this.id;
    }

    public void setId(long id) {
       this.id = id; 
    } 
    
    public String getUrl() {
        return this.url;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public Blob getCert() {
        return this.cert;
    }

    public byte[] getCertAsByteArray() throws IOException {
      if (this.cert ==  null) {
        return null;
      }
      try {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        MiscUtil.dumpInputOutputStream(cert.getBinaryStream(), bos);
        return bos.toByteArray();
      } catch(SQLException e) {
        throw new IOException(e.getMessage());
      }
    }
    
    public void setCert(Blob cert) {
        this.cert = cert;
    }
    
    public void setCert(byte[] cert) {
      if (cert == null) {
        return;
      }
      this.cert = Hibernate.createBlob(cert);
    }

    public String getMimetypes() {
        return this.mimetypes;
    }

    public void setMimetypes(String mimetypes) {
        this.mimetypes = mimetypes;
    }

    public String getBpk() {
        return this.bPK;
    }

    public void setBpk( String bPK) {
        this.bPK = bPK;
    }
}
