/*
 * Copyright 2004 Bundeskanzleramt sterreich
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package moazs.util;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.io.OutputStream;
import javax.activation.DataSource;

public class ByteArrayDataSource implements DataSource {
   private byte[] bytes;
   private String contentType;
   private String name;

   public ByteArrayDataSource(byte[] bytes, String contentType, String name) {
      this.bytes = bytes;
      this.contentType = (contentType==null) ? "application/octet-stream" : contentType;
      this.name = name;
   }

   public String getContentType() {
      return contentType;
   }

   public InputStream getInputStream() {
      return new ByteArrayInputStream(bytes,0,bytes.length);
   }

   public String getName() {
      return name;
   }

   public OutputStream getOutputStream() throws java.io.IOException {
      throw new java.io.FileNotFoundException();
   }
}

