package moazs.util;

import java.util.List;

import moazs.modell.DeliveryQuality;
import moazs.modell.Status;

import org.apache.log4j.Logger;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Restrictions;

public class HibernateSearch {

  static private Logger logger = Logger.getLogger(HibernateSearch.class);
  
  public static DeliveryQuality getDeliveryQuality(String name) {
    List result = searchByCriteria(DeliveryQuality.class, MiscUtil.criterionToArray(Restrictions.eq("name", name)));
    if (result.size() == 0) {
      return null;
    }
    return (DeliveryQuality) result.get(0);
  }

  public static Status getStatus(String name) {
    List result = searchByCriteria(Status.class, MiscUtil.criterionToArray(Restrictions.eq("name", name)));
    if (result.size() == 0) {
      return null;
    }
    return (Status) result.get(0);
  }

  
  public static List searchByCriteria(Class clazz, Criterion[] criterions) {
    List result = null;
    try {
      Session session = HibernateUtil.getCurrentSession();

      Criteria criteria = session.createCriteria(clazz);

      if (MiscUtil.isNotEmpty(criterions)) {
        logger.debug( "Looking for (criterion(s) = " + MiscUtil.toString(criterions) + ").");
        for (int i=0; i < criterions.length; i++) {
          criteria.add(criterions[i]);
        }
      }
      logger.debug( "Effective criteria: " + criteria.toString());
      result = criteria.list();
    } catch (HibernateException hex) {
      logger.warn("Fehler bei der Suche aufgetreten.", hex);
    }
    return result;
  }
  
}
