import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Date;

import junit.framework.TestCase;
import moazs.async.MoaWorker;
import moazs.modell.DeliveryQuality;
import moazs.modell.Payload;
import moazs.modell.Rcpt;
import moazs.modell.Request;
import moazs.modell.Status;
import moazs.util.MoaFactory;
import net.sf.workqueue.WorkQueue;

import org.hibernate.HibernateException;
import org.hibernate.classic.Session;

public class TestAsync extends TestCase {
    public TestAsync(String name) {
        super(name);
    }

    public void testHttp() {
        new Thread(new Runnable() {
            public void run() {
                try {
                    ServerSocket ssock = new ServerSocket(9999);
                    Socket sock = ssock.accept();
                    BufferedReader isr = new BufferedReader(new InputStreamReader(sock.getInputStream()));
                    BufferedWriter owr = new BufferedWriter(new OutputStreamWriter( sock.getOutputStream()));
                    String request = isr.readLine();
                    if ("GET /foo HTTP/1.1".equals(request)) {

                        owr.write("HTTP/1.1 200 OK\n");
                        owr.write("Server: dummythread\n");
                        owr.write("Accept-Ranges: bytes\n");
                        owr.write("Content-Length: 3\n");
                        owr.write("Keep-Alive: timeout=15, max=100\n");
                        owr.write("Connection: Keep-Alive\n");
                        owr.write("Content-Type: text/plain\n");
                        owr.write("\n");
                        owr.write("Foo");
                        owr.flush();
                        owr.close();

                    }
                    isr.close();
                    sock.close();
                    ssock.close();
                } catch (java.io.IOException ioe) {
                    ioe.printStackTrace();
                }
            }
        }).start(); 

        try {
            Thread.sleep(500);
        } catch (InterruptedException ie) {
        }

        try {
            Session sess = MoaFactory.getSession();
            
            Request r = new Request();
            r.setStatus((Status) sess.load(Status.class, new Long(0)));
            r.setSenderProfileId("");
            r.setSignatureProfileId("");
            r.setDeliveryQuality((DeliveryQuality)sess.load(DeliveryQuality.class, new Long(0)));
            Rcpt rcpt = new Rcpt();
            sess.save(rcpt);
            r.setRcpt(rcpt);
            r.setTs(new Date());
            sess.save(r);
            sess.flush(); 
            Payload p = new Payload();
            p.setUrl("http://localhost:9999/foo");
            p.setRequest(r);
            r.addPayload(p);
            sess.save(p);
            sess.flush();
            sess.connection().commit();
            sess.close();

            MoaWorker mw = new MoaWorker( );
            mw.setQueue( new WorkQueue());
            mw.doSomething(new Long(r.getId()));

            sess = MoaFactory.getSession();
            r = (Request)sess.load(Request.class, new Long(r.getId()));
            Payload pn = (Payload)r.getPayload().toArray()[0];

            assertEquals("callback payload", "Foo", new String( pn.getDataAsByteArray()) );
            sess.delete(r);
            sess.flush();
            sess.connection().commit();
            sess.close();
        } catch (HibernateException he) {
            he.printStackTrace();
            fail("hibernate Exception");
        } catch (java.sql.SQLException se) {
            se.printStackTrace();
            fail("SQLException");
        } catch (IOException e) {
          e.printStackTrace();
          fail("SQLException");
        }

    }

}
