import java.io.IOException;
import java.util.Date;

import junit.framework.TestCase;
import moazs.modell.DeliveryQuality;
import moazs.modell.Payload;
import moazs.modell.Rcpt;
import moazs.modell.Request;
import moazs.modell.Status;
import moazs.modell.XmlDocument;
import moazs.util.MoaDeckblatt;
import moazs.util.MoaFactory;

import org.hibernate.HibernateException;
import org.hibernate.classic.Session;

public class TestDeckblatt extends TestCase {
    public TestDeckblatt(String name) {
        super(name);
    }

    public void testDeckblatt() {
        try {
            Session sess = MoaFactory.getSession();
            
            Request r = new Request();
            r.setStatus((Status) sess.load(Status.class, new Long(2)));
            r.setSenderProfileId("123456");
            r.setTs(new Date());
            r.setSignatureProfileId("");
            r.setDeliveryQuality((DeliveryQuality)sess.load(DeliveryQuality.class, new Long(0)));
            Rcpt rcpt = new Rcpt();
            rcpt.setPhysicalPerson(true);
            rcpt.setGivenname("Foo");
            rcpt.setFamilyname("Bar");
            sess.save(rcpt);
            r.setRcpt(rcpt);
            r.setTs(new Date());
            sess.save(r);
            Payload p = new Payload();
            p.setData(new String("Foobar").getBytes());
            p.setFilename("foobar.txt");
            p.setRequest(r);
            r.addPayload(p);
            sess.save(p);
            sess.flush();
            sess.connection().commit();
            sess.close();
            
            MoaDeckblatt db = new MoaDeckblatt();
            XmlDocument deckblatt = db.makeDeckblatt(r);

            System.out.println( new String(deckblatt.getDataAsByteArray()));
            
            sess = MoaFactory.getSession();
            sess.delete(r);
            sess.flush();
            sess.connection().commit();
            sess.close();
        } catch (HibernateException he) {
            he.printStackTrace();
            fail("hibernate Exception");
        } catch (java.sql.SQLException se) {
            se.printStackTrace();
            fail("SQLException");
        } catch (IOException se) {
          se.printStackTrace();
          fail("IOException");
      }
    }
}
