/*
 * Created on 02-Aug-2004
 *
 * by Rainer Treutlein
 *
 * Project: moazs  2004
 * Release:
 *
 */


import junit.framework.TestCase;
import java.util.Properties;
import java.util.logging.FileHandler;
import java.util.logging.Formatter;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.logging.Handler;
import moazs.util.MoaConfig;

/**
 * @author Rainer Treutlein on 02-Aug-2004
 *
 *
 */
public class TestMoaConfig extends TestCase {

    public void testMoaConfig() {
        MoaConfig mcfg = new MoaConfig();
        String aProperty = mcfg.getProperty("nonexistingvalue");
        assertNull(aProperty);
        String bProperty = mcfg.getProperty("Application.Name");
        assertEquals("MOA-ZS",bProperty);
        
    }

    public void testGetHibernateProperties() {
        MoaConfig mcfg = new MoaConfig();
        Properties myprob = mcfg.getHibernateProperties();
        assertNotNull(myprob);
        assertNotSame(new Properties(),myprob);
        String testvalue = myprob.getProperty("hibernate.dialect");
        assertNotNull(testvalue);
        
    }

    public void testSetLogging() {
        
        MoaConfig mcfg = new MoaConfig();    
        Handler[] logHandler = Logger.getLogger("").getHandlers();
        assertNotNull(logHandler[0]);
        Level logLevel = logHandler[0].getLevel();
        assertNotNull(logLevel);
        Formatter fm = logHandler[0].getFormatter();
        assertNotNull(fm);
    }
}
