
import java.sql.SQLException;
import java.util.Date;
import java.util.HashSet;

import junit.framework.TestCase;
import moazs.external.MoaDelivery;
import moazs.modell.DeliveryQuality;
import moazs.modell.Payload;
import moazs.modell.Postaladdress;
import moazs.modell.Rcpt;
import moazs.modell.Request;
import moazs.modell.Status;
import moazs.modell.Zuseserver;
import moazs.util.MoaFactory;

import org.hibernate.HibernateException;
import org.hibernate.classic.Session;

/*
 * Created on 26-Aug-2004
 *
 * by Rainer Treutlein
 *
 * Project: moazs  2004
 * Release:
 *
 */

/**
 * @author Rainer Treutlein on 26-Aug-2004
 * 
 *  
 */
public class TestMoaDelivery extends TestCase {

    /*
     * Class under test for void MoaDelivery(Session, Request)
     */
    public void testMoaDeliverySessionRequest() {
    }

    private Request createTestData(String zuseServerUrl) {

        Request r = new Request();
        try {
            Session sess = MoaFactory.getSession();

            r.setStatus((Status) sess.load(Status.class, new Long(3)));
            r.setSenderProfileId("123456");
            r.setSignatureProfileId("Signaturdienst_I");
            r.setAppDeliveryId("0815");

            r.setDeliveryQuality((DeliveryQuality) sess.load(DeliveryQuality.class, new Long(0)));

            Rcpt rcpt = new Rcpt();
            Date nd = new Date();
            rcpt.setDateofbirth(nd);
            rcpt.setFamilyname("bar");
            rcpt.setGivenname("foo");
            rcpt.setPhysicalPerson(true);
            sess.save(rcpt);
            sess.flush();
            r.setRcpt(rcpt);
            r.setTs(new Date());
            sess.save(r);
            sess.flush();

            Postaladdress pa = new Postaladdress();
            pa.setPostalcode("1234");
            pa.setMunicipality("wien");
            pa.setStreetname("foobarweg");
            pa.setBuilding("12");
            pa.setRcpt(rcpt);
            sess.save(pa);
            sess.flush();

            HashSet postAdd = new HashSet();
            postAdd.add(pa);

            rcpt.setPostaladdress(postAdd);

            r.setRcpt(rcpt);

            Zuseserver z = new Zuseserver();
            z.setBpk("54321");
            z.setUrl(zuseServerUrl);
            sess.save(z);
            r.setZuseserver(z);

            HashSet payloads = new HashSet();
            Payload p1 = new Payload();
            p1.setData(new String("Foobar").getBytes());
            p1.setFilename("foobar.txt");
            p1.setMimetype("multipart/mixed");
            p1.setRequest(r);
            payloads.add(p1);

            sess.save(p1);
            r.setPayload(payloads);

            sess.flush();
            sess.connection().commit();

        } catch (HibernateException he) {
            he.printStackTrace();
            fail("HibernateException");
        } catch (SQLException se) {            
            se.printStackTrace();
            fail("SQLException");
        }
        return r;

    }

    public void testCreateDeliveryRequest() {
        Session sess = null;
        Request r = null;

        sess = MoaFactory.getSession();
        r = createTestData("http://localhost:8000/zuse?error");
        
        //MoaDelivery md = new MoaDelivery();        
        
        int status = new MoaDelivery().createDeliveryRequest(sess, r);
        
        assertEquals(status,0);
        
        r = createTestData("http://localhost:8000/zuse?success");
        //md = new MoaDelivery();
        
        status = new MoaDelivery().createDeliveryRequest(sess, r);
        
        assertEquals(status, 1);
        

        //String result = new String(mss.sign(deckblatt, payloads, "Signaturdienst_I"));
        // System.out.println( new String(result));
    }

}

