import java.io.FileReader;
import java.security.KeyPair;
import java.util.Date;

import javax.crypto.Cipher;

import junit.framework.TestCase;
import moazs.api.MoaException;
import moazs.external.MoaSZR;
import moazs.modell.Rcpt;

import org.bouncycastle.openssl.PEMReader;
import org.bouncycastle.openssl.PasswordFinder;
import org.bouncycastle.util.encoders.Base64;
public class TestSZR extends TestCase {
    public TestSZR(String name) {
        super(name);
    }

    public void testTransform() {
        //Session sess = MoaFactory.getSession();
        Rcpt rcpt = new Rcpt();
        rcpt.setFamilyname("Posch");
        rcpt.setGivenname("Reinhard");
        rcpt.setDateofbirth(new Date(51, 3, 16));
        MoaSZR mszr = new MoaSZR();
        String result = null;
        try {
          result = mszr.transform(rcpt, "urn:publicid:gv.at:cdid+ABC", "h+MgEQonXh7F0IrJjxON/tj4APg=");
          System.out.println( result );
        } catch(MoaException e) {
          e.printStackTrace();
          fail("Error transforming bPK");
        }
        try {
            System.out.println( decode( Base64.decode(result.getBytes())));
        } catch (Exception e) {
            e.printStackTrace();
            fail("Decoding failed!");
        }
        assertEquals("Resultat", "12341234", result);
    }

    public String decode(byte[] in) throws Exception  {

        Cipher cipher = null;
        try {
            cipher = Cipher.getInstance("RSA","BC");

        } catch (Exception e) {
            System.err.println(e);
            return "";
        }
        KeyPair key = null;

        FileReader fr = new FileReader("priv.pem");
        PEMReader rd = new PEMReader(fr, new GuruPwReader(), "BC");
        Object o = null;
        while ((o = rd.readObject()) != null) {
            if (o instanceof KeyPair){
                key = (KeyPair)o;
            }
        }
        cipher.init(Cipher.DECRYPT_MODE, key.getPrivate());

        byte[] dec = cipher.doFinal( in );
        return new String(dec);
    }
}

class GuruPwReader implements PasswordFinder {
    public char[] getPassword() {
        return new String("foobar").toCharArray();
    }
}


