/*
 * Copyright 2004 Bundeskanzleramt sterreich
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ 

package moazs.modell;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.Blob;
import java.sql.SQLException;

import moazs.util.MiscUtil;

import org.hibernate.Hibernate;

public class Payload {
    private long id;
    private Request request;
    private String filename;
    private String mimetype;
    private String url;
    private String md5checksum;
    private boolean base64;
    //private Blob data;
    private Blob data;
    
    public Payload() {
    }

    public long getId() {
        return this.id;
    }

    public void setId( long id) {
        this.id = id;
    }

    public Request getRequest() {
        return this.request;
    }

    public void setRequest(Request request) {
        this.request = request;
    }

    public String getFilename() {
        return this.filename;
    }

    public void setFilename( String filename) {
        this.filename = filename;
    }
    
    public String getMimetype() {
        return this.mimetype;
    }
    
    public void setMimetype( String mimetype) {
        this.mimetype = mimetype;
    }
    
    public String getUrl() {
        return this.url;
    }

    public void setUrl(String url) {
        this.url = url;
    }
    
    public String getMd5checksum() {
        return this.md5checksum;
    }

    public void setMd5checksum( String md5checksum) {
        this.md5checksum = md5checksum;
    }

    public Blob getData() {
        return this.data;
    }

    public byte[] getDataAsByteArray() throws IOException {
      try {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        MiscUtil.dumpInputOutputStream(data.getBinaryStream(), bos);
        return bos.toByteArray();
      } catch(SQLException e) {
        throw new IOException(e.getMessage());
      }
    }
    
    public void setData(Blob data) {
        this.data = data;
    }
    
    public void setData(byte[] data) {
      this.data = Hibernate.createBlob(data);
    }
    
    public void setData(InputStream data) throws IOException {
      this.data = Hibernate.createBlob(data);
    }

    public boolean getBase64() {
        return this.base64;
    }

    public void setBase64(boolean base64) {
        this.base64 = base64;
    }
}
